diff -urN xhost.orig/Imakefile xhost/Imakefile
--- xhost.orig/Imakefile	2003-11-14 16:54:53.000000000 +0100
+++ xhost/Imakefile	1970-01-01 01:00:00.000000000 +0100
@@ -1,16 +0,0 @@
-XCOMM $Xorg: Imakefile,v 1.3 2000/08/17 19:54:24 cpqbld Exp $
-#if HasSecureRPC
-RPC_DEFINES = -DSECURE_RPC
-#else
-RPC_DEFINES = 
-#endif
-KRB5_DEFINES = Krb5Defines
-KRB5_INCLUDE = Krb5Includes
-       INCLUDES = $(KRB5_INCLUDE)
-        DEPLIBS = $(DEPXMULIB) $(DEPXLIB)
-LOCAL_LIBRARIES = $(XMULIB) $(XLIB)
-           SRCS = xhost.c 
-           OBJS = xhost.o 
-        DEFINES = ConnectionFlags $(SIGNAL_DEFINES) $(RPC_DEFINES) $(KRB5_DEFINES)
-
-ComplexProgramTarget(xhost)
diff -urN xhost.orig/Makefile.am xhost/Makefile.am
--- xhost.orig/Makefile.am	1970-01-01 01:00:00.000000000 +0100
+++ xhost/Makefile.am	2004-08-15 17:43:47.000000000 +0200
@@ -0,0 +1,53 @@
+# 
+#  $Id: Makefile.am,v 1.2 2004/06/25 19:38:50 markh Exp $
+# 
+#  Copyright © 2003 Keith Packard
+# 
+#  Permission to use, copy, modify, distribute, and sell this software and its
+#  documentation for any purpose is hereby granted without fee, provided that
+#  the above copyright notice appear in all copies and that both that
+#  copyright notice and this permission notice appear in supporting
+#  documentation, and that the name of Keith Packard not be used in
+#  advertising or publicity pertaining to distribution of the software without
+#  specific, written prior permission.  Keith Packard makes no
+#  representations about the suitability of this software for any purpose.  It
+#  is provided "as is" without express or implied warranty.
+# 
+#  KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+#  INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
+#  EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+#  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
+#  DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+#  TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+#  PERFORMANCE OF THIS SOFTWARE.
+#
+
+AUTOMAKE_OPTIONS = 1.7 foreign
+
+AM_CFLAGS = @XHOST_CFLAGS@
+
+bin_PROGRAMS = xhost
+
+xhost_SOURCES = xhost.c
+
+xhost_LDADD = @XHOST_LIBS@
+
+man5_MANS=xhost.man
+
+EXTRA_DIST= $(man5_MANS)
+
+MAINTAINERCLEANFILES = configure \
+config.guess \
+config.sub \
+install-sh \
+ltmain.sh \
+missing \
+mkinstalldirs \
+aclocal.m4 \
+Makefile.in \
+depcomp \
+autoscan.log \
+configure.scan \
+config.h \
+config.h.in \
+$(man5_MANS)
diff -urN xhost.orig/configure.ac xhost/configure.ac
--- xhost.orig/configure.ac	1970-01-01 01:00:00.000000000 +0100
+++ xhost/configure.ac	2004-08-15 17:43:42.000000000 +0200
@@ -0,0 +1,57 @@
+dnl
+dnl $Id: configure.ac,v 1.1 2003/10/09 06:16:59 keithp Exp $
+dnl
+dnl Copyright © 2003 Keith Packard
+dnl
+dnl Permission to use, copy, modify, distribute, and sell this software and its
+dnl documentation for any purpose is hereby granted without fee, provided that
+dnl the above copyright notice appear in all copies and that both that
+dnl copyright notice and this permission notice appear in supporting
+dnl documentation, and that the name of Keith Packard not be used in
+dnl advertising or publicity pertaining to distribution of the software without
+dnl specific, written prior permission.  Keith Packard makes no
+dnl representations about the suitability of this software for any purpose.  It
+dnl is provided "as is" without express or implied warranty.
+dnl
+dnl KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+dnl INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
+dnl EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+dnl CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
+dnl DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+dnl TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+dnl PERFORMANCE OF THIS SOFTWARE.
+dnl
+
+AC_PREREQ(2.57)
+AC_INIT([xhost],4.4.0,[],xhost)
+AC_CONFIG_SRCDIR([Makefile.am])
+AM_INIT_AUTOMAKE([dist-bzip2])
+AM_MAINTAINER_MODE
+AM_CONFIG_HEADER(config.h)
+
+AC_PROG_CC
+AC_PROG_INSTALL
+AC_PROG_LN_S
+AC_LIBTOOL_WIN32_DLL
+AM_PROG_LIBTOOL
+AC_PROG_MAKE_SET
+
+PKG_CHECK_MODULES(XHOST, xext xmuu x11)
+
+AC_TYPE_SIGNAL
+
+# Transport selection
+AC_ARG_ENABLE(unix-transport,[  --disable-unix-transport ], [UNIXCONN=$enableval], [UNIXCONN=yes])
+AC_ARG_ENABLE(tcp-transport, [  --disable-tcp-transport ], [TCPCONN=$enableval], [TCPCONN=yes])
+AC_ARG_ENABLE(ipv6,          [  --disable-ipv6 ], [IPV6CONN=$enableval], [IPV6CONN=yes])
+if test "$UNIXCONN" = "yes"; then
+	AC_DEFINE(UNIXCONN,1,[Support UNIX socket connections])
+fi
+if test "$TCPCONN" = "yes"; then
+	AC_DEFINE(TCPCONN,1,[Support TCP socket connections])
+fi
+if test "$IPV6CONN" = "yes"; then
+	AC_DEFINE(IPv6,1,[Support IPv6 for TCP connections])
+fi
+
+AC_OUTPUT([Makefile])
diff -urN xhost.orig/xhost.c xhost/xhost.c
--- xhost.orig/xhost.c	2003-11-14 16:54:53.000000000 +0100
+++ xhost/xhost.c	2004-08-15 17:53:07.000000000 +0200
@@ -27,6 +27,10 @@
 
 */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if defined(TCPCONN) || defined(STREAMSCONN)
 #define NEEDSOCKETS
 #endif
@@ -102,11 +106,7 @@
 static int local_xerror();
 static char *get_hostname();
 
-#ifdef SIGNALRETURNSINT
-#define signal_t int
-#else
-#define signal_t void
-#endif
+#define signal_t RETSIGTYPE
 static signal_t nameserver_lost();
 
 #define NAMESERVER_TIMEOUT 5	/* time to wait for nameserver */
